/**
 * Created by SunQian on 2017/6/27.
 */

var vm;
var componentParentComment = {
    template: "#parent-comment-template",
    props: [ "data" ],
    methods: {
        init: function() {
            /** 处理评论表情 **/
            replaceCommentFace();
        },
        onShowMoreParentCommentClick: function( commentId, commentIds ) {
            /** 显示全部回复楼层 **/
            onClickMoreCommentReply( commentId, commentIds );
        },
        onClickContentImage: function( index, url, imageList ) {
            /** 打开评论大图 **/
            var list = [];
            for( var i = 0; i < imageList.length; i++ ) list.push( imageList[i].pictureUrl );
            showImageSwiper( index, list );
        }
    },
    updated: function() { this.init(); },
    mounted: function() { this.init(); }
};
Vue.component( "parent-comment", componentParentComment );

/** 获得详细页JSON **/
function setBody( detail ) {
    /** 处理评论盖楼数据，之后正式初始化Vue **/
    loopCommentIndex = -1;
    loopParentComment( detail.commentList, function( commentList ) {
        /** 初始化数据 **/
        vm = new Vue( {
            el: ".base",
            data: {
            	id:detail.id,
                title: detail.title, source: detail.source, publishTime: detail.publishTime, editor: detail.editor,
                topCount: detail.topCount,
                content: detail.text,
                showAd: detail.templateStyle.isSupportAd == true ? 1 : 0,
                showComment: detail.templateStyle.isSupportLatestComment == true ? 1 : 0,
                showRelative: detail.templateStyle.isSupportRelatedNews == true ? 1 : 0,
                commentNum: detail.templateStyle.latestCommentsCount,
                relativeNum: detail.templateStyle.relatedNewsCount,
                commentList: commentList,
                relatedList: detail.relatedList,
                adList: detail.ads || ( detail.ad.adId ? [ detail.ad ] : [] ),
                /** 是否显示自媒体信息 **/
                //isWeMedia: 1 == ( $_BASE.getLocationParam( "we-media" ) || 0 ),
                isWeMedia: detail.selfChannelOrNot == true,
                /** 自媒体用户昵称 **/
                weMediaNick: detail.selfChannelName,
                /** 自媒体用户头像 **/
                weMediaPortrait: "images/user_default.png",
                /** 自媒体频道id **/
                weMediaChannelId: detail.selfChannelId
            },
            methods: {
                init: function() {
                    /** 处理正文中段首空格占位 **/
                    replaceNBSP();
                    /** 处理正文中的图片点击放大 **/
                    addImgListener();
                    /** 处理正文中的内链点击 **/
                    addContentLinkListener();
                    /** 处理正文中的视频 **/
                    replaceVideo();
                    /** 处理正文音频 **/
                    replaceAudio();
                    /** 强制处理图片、表格、内链 **/
                    formatContent();
                    /** 评论表情替换 **/
                    replaceCommentFace();
                },
                onRelatedClick: function( index, content ) {
                    /** 点击相关新闻 **/
                    onClickRelatedContent( content.contentId );
                },
                onAdClick: function( index, ad ) {
                    /** 点击占位广告 **/
                    onClickAd( ad, detail.code );
                },
                onClickContentImage: function( index, url, imageList ) {
                    /** 打开评论大图 **/
                    var list = [];
                    for( var i = 0; i < imageList.length; i++ ) list.push( imageList[i].pictureUrl );
                    showImageSwiper( index, list );
                },
                onPraiseClick: function() {
                    /** 文章点赞 **/
                    onClickTop();
                },
                subscribeWeMedia: function() {
                    /** 订阅自媒体 **/
                    onClickSubscribeWeMedia();
                }
            },
            updated: function() {
                var me = this; me.init();
            },
            mounted: function() {
                /** 显示页面 **/
                $( ".loading" ).hide();
                $( ".base" ).removeClass( "off" );
                $( ".big_swiper" ).removeClass( "off" );
                /** 初始化 **/
                var me = this;
                me.init();
                /** 广告滑动设置 **/
                new Swiper( ".ad .swiper-container", {
                    pagination: ".swiper-pagination",
                    paginationClickable: true,
                    slidesPerView: 1,
                    spaceBetween: 0,
                    loop: me.adList.length > 1,
                    autoplay: 2500,
                    autoplayDisableOnInteraction: false,
                    onClick: function( swiper, event ) { console.dir( swiper );
                        var index = ( swiper.activeIndex - 1 ) % me.adList.length;
                        me.onAdClick( index, me.adList[index] );
                    }
                } );
            }
        } );
    } );
}




/** 处理评论盖楼数据，之后正式初始化Vue **/
var loopCommentIndex = -1;
function loopParentComment( list, callback ) {
    if( ++loopCommentIndex == list.length ) { callback( list ); return; }
    var comment = list[loopCommentIndex];
    if( comment.createdTime == null )
        comment.createdTime = comment.createTime;
    var parentList = comment.parent.parentList;
    /** 楼层数多的时候，展示3条（1、2、more、n）和查看更多楼层。因为parentIds中包含当前评论的id，所以要-1获取楼层数 **/
    var treeLength = comment.parent.parentIds.split( "," ).length - 1;
    var showMoreButton = treeLength > 3 && parentList.length < treeLength;
    var pIndex = parentList.length;
    function loop( parentData ) {
        if( --pIndex < 0 ) { loopParentComment( list, callback ); return; }
        /** 起始楼层序号。
         * 全部展开，所有的按照楼层显示序号。
         * 折叠，显示1、2、点击查看更多楼层、n （ n表示全部楼层数，且n > 3 ）
         **/
        parentData.parentData = parentList[pIndex];
        if( parentData.parentData.createdTime == null )
            parentData.parentData.createdTime = parentData.parentData.createTime;
        parentData.parentData.rowNum = pIndex + 1;
        if( pIndex == parentList.length - 1 && showMoreButton ) {
            parentData.parentData.rowNum = treeLength;
            parentData.parentData.parentData = { isMore:true, comment:"显示全部楼层", commentId: comment.id, commentIds: comment.parent.parentIds };
            loop( parentData.parentData.parentData );
        }
        else {
            loop( parentData.parentData );
        }
    }
    loop( comment );
}



/** 处理正文中的段首占位空格 **/
function replaceNBSP() {
    if(  $( ".content" ).length == 0 ) return;
    var nodes = $( ".content" ).get(0).childNodes;
    if( nodes )
        for( var i = 0; i < nodes.length; i++ ) {
            var innerHTML = nodes[i].innerHTML;
            if( innerHTML ) {
                var str = "";
                for( var s = 0; s < innerHTML.length; s++ ) {
                    if( innerHTML[s] == " " )
                        str += "&nbsp;";
                    else {
                        if( s > 0 ) innerHTML = innerHTML.replace( innerHTML.substr( 0, s ), str );
                        break;
                    }
                }
                nodes[i].innerHTML = innerHTML;
            }
        }
}




/** 处理正文中的内链点击 **/
function addContentLinkListener() {
    $( ".content label[data-plugin-type='content']" ).each( function( i, lab ) {
        lab.onclick = onClickContentLink;
    } );
}




/** 处理正文中的图片点击放大 **/
function addImgListener() {
    $( ".content img" ).each( function( i, img ) {
        if( img.getAttribute( "data-plugin-type" == "video" ) ) return true;
        img.setAttribute( "data-index", i );
        img.onclick = onClickContentImage;
    } );
}

function stopOtherVideos (that) {
    const videos = document.getElementsByTagName("video");
    for(let i=0;i<videos.length;i++){
        videos[i].addEventListener("play",function (that) {
            const videos = document.getElementsByTagName("video");
            for(let i=0;i<videos.length;i++){
                tagss = that
                console.log(videos[i].id,that.path[0].id);
                if(videos[i].id != that.path[0].id){
                    videos[i].pause();
                }
            }
        },false);
    }
}


/** 处理正文视频 **/
function replaceVideo() {
    /**
     <section data-plugin-type='video' style='text-align:center;margin-bottom:1em;'>
     <img src='节目图片' data-value='节目JSON' style='max-width:100%;height:auto;margin:10px auto;'></img>
     </section>
     **/
    /**
     {
        id: [ Integer ] 节目ID,
        createdTime: [ String ] 创建时间，yyyy-MM-dd hh:mm:ss,
        programName: [ String ] 节目名称,
        image: [ String ] 节目缩略图,
        video: [ Object ] 节目下视频
        {
            videoId: [ Integer ] 视频ID,
            displayName: [ String ] 视频名称,
            videoImage: [ String ] 视频图片,
            streamList: [ Array ] 码流列表
            [
                {
                    streamId: [ Integer ] 码流名称ID,
                    streamDisplayName: [ String ] 码流显示名称
                    url: [ String ] 完整播放地址,
                    isDefault: [ Integer ] 默认播放1、是；0、否
                }
            ]
        }
     }
     **/
    /*$( "section[data-plugin-type='video']" ).each( function( i, section ) {
        var url = "";
        var program = JSON.parse( $( section ).find( "img" ).get(0).getAttribute( "data-value" ) );
        if( program && program.video && program.video.streamList && program.video.streamList.length > 0 ) {
            var stream = program.video.streamList[0];
            for( var s = 0; s < program.video.streamList.length; s++ )
                if( program.video.streamList[s].isDefault == 1 )
                    stream = program.video.streamList[s];
            url = stream.url;
        }
        $( section ).find( "img" ).before( "<video controls x5-playsinline='' playsinline='' webkit-playsinline='true' preload='none' src='" + url + "'></video>" );
        if( $( section ).find( "div" ).length == 0 )
            $( section ).append( "<div class='video_play_btn'></div>" );
        else
            $( section ).find( "div" ).replaceWith( "<div class='video_play_btn'></div>" );
        $( section ).find( ".video_play_btn" ).unbind( "click" );
        $( section ).find( ".video_play_btn" ).bind( "click", function( event ) {
            /!** 点击播放视频 **!/
            $( section ).find( "video" ).get(0).play();
        } );
        $( section ).find( "video" ).get(0).onended =
            $( section ).find( "video" ).get(0).onerror =
                $( section ).find( "video" ).get(0).onpause =
                    function() {
                        $( section ).find( "img" ).show();
                        $( section ).find( "div" ).show();
                        $( section ).find( "video" ).hide();
                    }
        $( section ).find( "video" ).get(0).onplay =
            $( section ).find( "video" ).get(0).onplaying =
                    function() {
                        $( section ).find( "img" ).hide();
                        $( section ).find( "div" ).hide();
                        $( section ).find( "video" ).show();
                    }
    } );*/
    $( "section[data-plugin-type='video']" ).each( function( i, section ) {
        $( section ).find( "div" ).replaceWith( "<div class='video_play_btn'></div>" );
        $( section ).find( ".video_play_btn" ).unbind( "click" );
        $( section ).find( ".video_play_btn" ).bind( "click", function( event ) {
            var program = JSON.parse( $( event.target ).parent( "section" ).find( "img" ).get(0).getAttribute( "data-value" ) );
            if( null == program ) return;
            var video = program.video;
            if( null == video ) return;
            if( null == video.streamList ) return;
            if( 0 == video.streamList.length ) return;
            var stream = video.streamList[0];
            for( var s = 0; s < video.streamList.length; s++ )
                if( video.streamList[s].isDefault == 1 )
                    stream = video.streamList[s];
            $( section ).replaceWith( "<video id='player"+i+"' data-idx='"+i+"' controls autoplay x5-playsinline='' playsinline='' webkit-playsinline='true' preload='auto' style='width:640px;height:auto;max-width:100%;background-color:#333333;margin:auto;display:none;'" + " poster='" + program.image + "' src='" + stream.url + "'></video>" );
            $("#player"+i).css("display","block");
            document.getElementById("player"+i).play();
            stopOtherVideos("player"+i);
        } );
    } );
}




/** 处理正文音频 **/
function replaceAudio() {
    $( "embed[data-plugin-type='audio']" ).each( function( index, embed ) {
        var program = JSON.parse( decodeURIComponent( embed.getAttribute( "data-value" ) ) );
        console.dir( program );
        var url = program.mmsURL + "/amc/getProgramVideoPlayUrl.jspa?callback=?";
        $.getJSON( url, { programId:program.id, programVideoId:program.video.videoId, videoType:"PC" }, function( res ) {
            var stream = res.data.streamList[0];
            $( embed ).replaceWith( "<audio controls src='" + stream.url + "'></audio>" );
        } );
    } );
}




/** 点击显示大图 **/
function onClickContentImage( event ) {
    var index = 0;
    var list = new Array();
    var activeImg = this;
    $( ".content" ).find( "img" ).each( function( i, img ) {
        list.push( img.src ); if( img == activeImg ) index = i;
    } );
    showImageSwiper( index, list );
}



/** 点击通知app打开内链 **/
function onClickContentLink() {
    var id = this.getAttribute( "data-id" );
    var originalId = this.getAttribute( "data-original-id" );
    var contentType = this.getAttribute( "data-content-type" );
    var location = window.location.href.replace( window.location.search, "" );
    var url = "../" + $_BASE.rootIndexURL + "?contentType=" + contentType + "&contentId=" + id + "&id=" + originalId;
    window.open( url, "_blank" );
}



/** 强制处理图片、表格、内链 **/
function formatContent() {
    $( ".content img, .content table" ).each( function( i, elem ) {
        if( elem.getAttribute( "data-plugin-type" ) == "video" ) return true;
        elem.style.maxWidth = "100%";
        elem.style.height = "auto";
        elem.style.margin = "0";
    } );
    $( "section[data-plugin-type]").css( "text-indent", "0" );
    $( "section[data-plugin-type]" ).find( "center" ).css( "text-indent", "0" );
}




/** 评论表情替换 **/
function replaceCommentFace() {
    $( ".comment" ).find( "emo" ).each( function( i, emo ) {
        $( emo ).replaceWith( "<img src='images/face/" + emo.innerHTML.split( "|" )[0] + ".gif'/>" );
    } );
}




/** 评论盖楼 **/
function loopReply( reList, selector, showMore, createComplete ) {
    var r = reList.length;
    function loop( container )
    {
        if( --r < 0 ) {
            if( showMore )
                $( selector ).before( "<div class='reply_more'>查看更多回复</div>" );
            createComplete(); return;
        }
        if( waitting ) { return; }
        var re = reList[r];
        var className = "reply";
        if( r == reList.length - 1 ) className += " reply_base";
        if( r == 0 ) className += " reply_inner";
        var str = "";
        str += "<div class='" + className + "'>";
        str +=		"<label class='reply_num'>" + re.number + "</label>";
        str +=		"<label class='reply_nick'>" + re.nick + "</label>";
        str +=		"<div class='reply_cmt'>" + re.comment + "</div>";
        str += "</div>";
        container.before( str );
        container = container.parent().find( ".reply .reply_num" );
        loop( container );
    }
    loop( $( selector ) );
}




/** 点击相关内容 **/
function onClickRelatedContent( id ) {
    var fromFlag = $_BASE.getLocationParam( "fromFlag" );
    if( Number( fromFlag ) == 1 ) fromFlag = "&fromFlag=1";
    else fromFlag = "";
    var url = "../" + $_BASE.rootIndexURL + "?contentType=5&contentId=" + id + fromFlag;
    window.open( url, "_blank" );
}


/** 广告点击 **/
function onClickAd( ad, contentCode ) {
    if( ad.type == 7 && ad.resultContent ) {
        var contentType = ad.resultContent.adContentType;
        var contentId = ad.resultContent.adContentId;
        var url = "../" + $_BASE.rootIndexURL + "?contentType=" + ad.resultContent.adContentType
        if( contentType == 1 ) {
            /** 活动 **/
            url += "&activityId=" + ad.resultContent.adContentId + "&contentCode=" + contentCode;
        }
        else if( contentType == 2 ) {
            /** 抽奖 **/
            $.cookie( "callbackURL", window.location.href, { path: "/" } );
            url += "&drawRaffleId=" + ad.resultContent.adContentId + "&freeFlag=0&contentCode=" + contentCode;
        }
        else if( contentType == 3 || contentType == 4 || contentType == 1 ) {
            /** 3、投票；4、直播间；10、问卷 **/
            url += "&id=" + ad.resultContent.adContentId + "&contentCode=" + contentCode;
        }
        else
            url += "&contentId=" + ad.resultContent.adContentId;
        window.open( url, "_blank" );
    }
    else if( ad.link.length > 0 ) window.open( ad.link, "_blank" );
    else  window.open( "../" + $_BASE.rootIndexURL + "?contentType=8&adId=" + ad.adId, "_blank" );
    /** 广告点击统计 **/
    $AD_STATISTICS.click( ad );
}




/** 显示全部回复楼层 **/
function onClickMoreCommentReply( commentId, commentIds ) {
    $( ".loading" ).show();
    var url = $_BASE.shinyv_url + "/client/listCommentByCommentIds?callback=?";
    $.getJSON( url, { commentIds: commentIds }, function( res ) { $( ".loading" ).hide(); setMoreCommentReply( commentId, res ); } );
}




/** 设置更多评论楼层 **/
function setMoreCommentReply( commentId, jsonString ) {
    var result;
    if( window.java && typeof window.java.getMoreCommentReply == "function" ) {
        jsonString = window.java.getMoreCommentReply();
        result = JSON.parse( jsonString );
    }
    else result = jsonString;
    /** 列表最后一项数组，是当前要展现的评论的所有楼层（包括当前评论） **/
    var list = result.data.list[ result.data.list.length - 1 ];
    var comment, index;
    if( vm ) {
        for( var i = 0; i < vm.$data.commentList.length; i++ )
            if( commentId == vm.$data.commentList[i].id ) index = i;
        comment = vm.$data.commentList[index];
        if( comment ) {
            /** 去掉评论楼层中的当前评论 **/
            comment.parent.parentList = list.slice( 0, list.length - 1 );
            loopCommentIndex = -1;
            loopParentComment( [ comment ], function( commentList ) {
                vm.$data.commentList[index] = commentList[0];
            } );
        }
    }
}




/** 打开大图Swiper **/
var swiper_big;
var vm_big = new Vue( {
    activeIndex: 0,
    el: ".big_swiper",
    data: { showBigSwiper: false, images: [] },
    updated: function() {
        if( swiper_big ) swiper_big.destroy( false );
        $( ".swiper-wrapper" ).css( "transform", "translate3d(0px, 0px, 0px)" );
        var me = this;
        /** 大图预览滑动 **/
        if( me.showBigSwiper )
            swiper_big = new Swiper( ".big_swiper .swiper-container", { zoom:true } );
        swiper_big.slideTo( me.activeIndex, 0 );
    }
} )
function showImageSwiper( index, imageList ) {
    vm_big.activeIndex = index;
    vm_big.$data.images = imageList;
    vm_big.$data.showBigSwiper = true;
}




/** 订阅（取消订阅）自媒体 **/
function  onClickSubscribeWeMedia() {
    var url = "../" + $_BASE.rootIndexURL + "?contentType=" +  $_BASE.CONTENT_TYPE.WE_MEDIA;
    url += "&id=" + vm.$data.weMediaChannelId + "&nodeCode=" + $_BASE.uniqueCode;
    window.open( url, "_blank" );
}



/** 文章点赞 **/
function onClickTop() {// setTop( 10000 ); return;
    /*判断是否对文章已经点过赞了，如果点过直接提示已经点过赞了，调接口点赞*/
    var onlystr = $_BASE.uniqueCode.split("-")[0];
    var topids = localStorage.getItem("topCount_"+onlystr);
    if(topids){
        var ids = topids.split(",");
        if(ids.indexOf(vm._data.id.toString()) != -1){
            alert("您已经点过赞了");
            return false;
        }
    }
    //调用接口
    var url = $_BASE.shinyv_url + '/client/addTopDataByContent?contentType=5&contentId='+vm._data.id+'&callback=?';
    $.getJSON(url,function(res){
        if(res.suc == 1 && res.data.suc == 1 ){
            vm._data.topCount ++ ;
            if(topids){
                var ids = topids.split(",");
                ids.push(vm._data.id);
                localStorage.setItem("topCount_"+onlystr , ids.join(","));
            }else{
                localStorage.setItem("topCount_"+onlystr , vm._data.id);
            }
            alert("点赞成功");
        }else{
            alert(res.data.message)
        }
    })
}